From c35beb32b74a30e08a3f15adecb8fe88539d3e18 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 21:18:36 +0100
Subject: [PATCH 18/54] feat: card style for overclock stats section

---
 lact-gui/src/app/root_stack/mod.rs            |  40 +-----
 .../app/root_stack/oc_page/clocks_frame.rs    |   3 +-
 .../root_stack/oc_page/gpu_stats_section.rs   |   2 +-
 lact-gui/src/app/root_stack/oc_page/mod.rs    |   8 +-
 lact-gui/ui/oc_page/gpu_stats_section.blp     | 120 +++++++++++-------
 5 files changed, 80 insertions(+), 93 deletions(-)

diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index f991b2fc..77739d60 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -4,7 +4,7 @@ mod software_page;
 mod thermals_page;
 
 use self::software_page::software_page;
-use gtk::{prelude::IsA, traits::GridExt, *};
+use gtk::{prelude::IsA, *};
 use info_page::InformationPage;
 use lact_client::schema::SystemInfo;
 use libadwaita::prelude::ActionRowExt;
@@ -33,7 +33,7 @@ impl RootStack {
 
         let oc_page = OcPage::new(&system_info);
 
-        container.add_titled(&oc_page.container, Some("oc_page"), "OC");
+        container.add_titled(&oc_page.container, Some("oc_page"), "Overclock");
 
         let thermals_page = ThermalsPage::new(root_win);
 
@@ -51,42 +51,6 @@ impl RootStack {
     }
 }
 
-#[deprecated]
-fn values_row<W: IsA<Widget>>(
-    title: &str,
-    parent: &Grid,
-    value_child: &W,
-    row: i32,
-    column_offset: i32,
-) {
-    let title_label = Label::builder().label(title).halign(Align::Start).build();
-
-    parent.attach(&title_label, column_offset, row, 1, 1);
-    parent.attach(value_child, column_offset + 1, row, 1, 1);
-}
-
-#[deprecated]
-fn label_row(title: &str, parent: &Grid, row: i32, column_offset: i32, selectable: bool) -> Label {
-    let value_label = Label::builder()
-        .halign(Align::End)
-        .hexpand(true)
-        .selectable(selectable)
-        .build();
-    values_row(title, parent, &value_label, row, column_offset);
-
-    value_label
-}
-
-#[deprecated]
-fn values_grid() -> Grid {
-    Grid::builder()
-        .margin_start(10)
-        .margin_end(5)
-        .row_spacing(10)
-        .column_spacing(10)
-        .build()
-}
-
 #[derive(Clone)]
 pub struct LabelRow {
     pub container: libadwaita::ActionRow,
diff --git a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
index 8297f599..263e0fd3 100644
--- a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
@@ -88,8 +88,7 @@ impl ClocksFrame {
 
         let clocks_data_unavailable_label = Label::builder()
             .label("No clocks data available")
-            .margin_start(10)
-            .margin_end(10)
+            .css_classes(["error"])
             .halign(Align::Start)
             .build();
 
diff --git a/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs b/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
index c1183b57..2093fbef 100644
--- a/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
+++ b/lact-gui/src/app/root_stack/oc_page/gpu_stats_section.rs
@@ -56,7 +56,7 @@ impl GpuStatsSection {
             .or(power_average);
 
         self.set_power_usage(format!(
-            "<b>{}/{}W</b>",
+            "{}/{}W",
             power_current.unwrap_or(0.0),
             power_cap_current.unwrap_or(0.0)
         ));
diff --git a/lact-gui/src/app/root_stack/oc_page/mod.rs b/lact-gui/src/app/root_stack/oc_page/mod.rs
index a5bca9d5..8261cbfc 100644
--- a/lact-gui/src/app/root_stack/oc_page/mod.rs
+++ b/lact-gui/src/app/root_stack/oc_page/mod.rs
@@ -22,6 +22,8 @@ use performance_frame::PerformanceFrame;
 use std::collections::HashMap;
 use tracing::warn;
 
+use super::list_clamp;
+
 const OVERCLOCKING_DISABLED_TEXT: &str = "Overclocking support is not enabled! \
 You can still change basic settings, but the more advanced clocks and voltage control will not be available.";
 
@@ -45,9 +47,7 @@ impl OcPage {
 
         let vbox = Box::builder()
             .orientation(Orientation::Vertical)
-            .spacing(15)
-            .margin_start(20)
-            .margin_end(20)
+            .spacing(12)
             .build();
 
         let mut enable_overclocking_button = None;
@@ -78,7 +78,7 @@ impl OcPage {
         vbox.append(&power_states_frame);
         vbox.append(&clocks_frame.container);
 
-        container.set_child(Some(&vbox));
+        container.set_child(Some(&list_clamp(&vbox)));
 
         Self {
             container,
diff --git a/lact-gui/ui/oc_page/gpu_stats_section.blp b/lact-gui/ui/oc_page/gpu_stats_section.blp
index 76105c13..7f068cd0 100644
--- a/lact-gui/ui/oc_page/gpu_stats_section.blp
+++ b/lact-gui/ui/oc_page/gpu_stats_section.blp
@@ -1,74 +1,98 @@
 using Gtk 4.0;
+using Adw 1;
 
 template $GpuStatsSection: $PageSection {
     name: "Statistics";
-    spacing: 10;
+    spacing: 12;
 
     Box {
-        orientation: horizontal;
-        spacing: 5;
+        styles ["card"]
+        orientation: vertical;
+        spacing: 12;
 
-        Label {
-            label: "VRAM Usage:";
-        }
+        Box {
+            orientation: vertical;
+            margin-top: 12;
+            margin-start: 12;
+            margin-end: 12;
+            spacing: 6;
 
-        Overlay {
-            LevelBar vram_usage_bar {
-                hexpand: true;
-                value: bind template.vram-usage;
-                orientation: horizontal;
+            Label {
+                label: "VRAM Usage";
+                xalign: 0.0;
             }
 
-            [overlay]
-            Label vram_usage_label {
-                label: bind template.vram-usage-text;
+            Overlay {
+                LevelBar vram_usage_bar {
+                    hexpand: true;
+                    height-request: 18;
+                    value: bind template.vram-usage;
+                    orientation: horizontal;
+                }
+
+                [overlay]
+                Label vram_usage_label {
+                    label: bind template.vram-usage-text;
+                }
             }
         }
-    }
 
-    Box {
-        orientation: horizontal;
-        spacing: 10;
+        Separator {
+            orientation: horizontal;
+        }
 
         Box {
-            orientation: vertical;
-            hexpand: true;
-            spacing: 5;
+            orientation: horizontal;
+            margin-bottom: 12;
+            margin-start: 12;
+            margin-end: 12;
+            homogeneous: true;
+            spacing: 12;
 
-            $InfoRow {
-                name: "GPU Core Clock:";
-                value: bind template.core-clock;
-            }
+            Box {
+                orientation: vertical;
+                hexpand: true;
+                spacing: 6;
 
-            $InfoRow {
-                name: "GPU Voltage:";
-                value: bind template.voltage;
-            }
+                $InfoRow {
+                    name: "GPU Core Clock:";
+                    value: bind template.core-clock;
+                }
+
+                $InfoRow {
+                    name: "GPU Voltage:";
+                    value: bind template.voltage;
+                }
 
-            $InfoRow {
-                name: "GPU Temperature (hotspot):";
-                value: bind template.temperature;
+                $InfoRow {
+                    name: "GPU Temperature (hotspot):";
+                    value: bind template.temperature;
+                }
             }
-        }
 
-        Box {
-            orientation: vertical;
-            hexpand: true;
-            spacing: 5;
+            //Separator {
+            //    orientation: vertical;
+            //}
 
-            $InfoRow {
-                name: "GPU Memory Clock:";
-                value: bind template.vram-clock;
-            }
+            Box {
+                orientation: vertical;
+                hexpand: true;
+                spacing: 6;
 
-            $InfoRow {
-                name: "GPU Usage:";
-                value: bind template.gpu-usage;
-            }
+                $InfoRow {
+                    name: "GPU Memory Clock:";
+                    value: bind template.vram-clock;
+                }
+
+                $InfoRow {
+                    name: "GPU Usage:";
+                    value: bind template.gpu-usage;
+                }
 
-            $InfoRow {
-                name: "Power Usage:";
-                value: bind template.power-usage;
+                $InfoRow {
+                    name: "Power Usage:";
+                    value: bind template.power-usage;
+                }
             }
         }
     }

